#!/user/local/bin/ruby -Ks
def showHelp; scrName = File::basename($0.gsub(/\\/, '/'));
puts <<"================================================"
#{scrName} v1.10  Copyright (C) 2005, nomad
Tv: BTONIC ` xml f[^o
\: ruby -Ks #{scrName} <dicName> [<outDir>]
  <dicName>  t@C (.exi)
  <outDir>   o̓fBNg (wȂȂJgfBNg)
:
  ruby -Ks #{scrName} "C:\\Program Files\\SANSEIDO BTONIC Viewer\\CrownFR\\CrownFR.exi"
================================================
end
=begin
o: *.xml  xml f[^t@C
:
  v1.00 2005-03-06 by nomad
    J
  v1.10 2005-10-23 by nomad
    [g̕fBNgɑΉ (Lt@wT)
: Copyright (C) 2005, nomad
      I[v\[X
=end

### 萔

SEGNAME_DATA = 'data'   # f[^ZOg
SEGNAME_FILE = 'list'   # t@CZOg
ROOT_SEGN = 0           # [gZOgԍ (0..)

# XCh@֌W
POS_BITS = 12    # ʒũrbg
LEN_BITS =  4    # ̃rbg
LEN_MASK = 0x0F  # 擾p̃}XN
LEN_DIF = 4      # Ǝۂ̒Ƃ̍
PL_CHAR = 0x00   # ʒuE̊Jn

###

# rbgo̓W[
module Bitio

  attr_accessor :getcount

=begin
  def initialize
    super
    @getcount = 0
  end
=end

  def getbit()
    @getcount -= 1
    if @getcount < 0
      @getcount = 7
      @bitbuf = self.getc
    end
    return (@bitbuf >> @getcount) & 1
  end

end

# nt}؂̍쐬
def maketree(f)
  tree = []
  count, root = f.read(4).unpack('nn')
  count.times do
    left, right = f.read(4).unpack('nn')
    tree.push([left, right])
  end
  return root, tree
end

# nt}k̓WJ
def decodehuffman(f, root, tree)
  j = root
  while j < 256
    j = tree[j][f.getbit()]
  end
  return j & 0xFF
end

# kf[^̓WJ (nt}k + XCh@)
def decode(f, root, tree, realsize)
  max = 2 ** POS_BITS   # obt@TCY
  text = Array::new(max)
  out = ''
  p = 0
  f.getcount = 0
  n = 0
  while n < realsize
    ch = decodehuffman(f, root, tree); n += 1
    if ch == PL_CHAR    # ʒuE̊Jn
      ch1 = decodehuffman(f, root, tree); n += 1
      ch2 = decodehuffman(f, root, tree); n += 1
      pos = ((ch2 >> LEN_BITS) << 8) + ch1   # ʃrbg + ʃrbg
      size = (ch2 & LEN_MASK) + LEN_DIF
      pos = (p - pos + max) % max
      size.times do |j|
        ch = text[(pos + j) % max]
        text[p] = ch; p = (p + 1) % max
        out << ch.chr
      end
    else
      text[p] = ch; p = (p + 1) % max
      out << ch.chr
    end
  end

  return out
end

def getsegnum(f, segs, segname, startnum = 0)
  pos, size = segs[startnum]
  f.pos = pos
  (size / 16).times do
    name, id, flag, segnum = f.read(16).unpack('A10A3Cn')
    if name == segname
      return segnum
    elsif flag == 0x01
      segnum = getsegnum(f, segs, segname, segnum)
      return segnum unless segnum.nil?
    end
  end
  return nil
end

# xml f[^̒o
def extract(fname, outdir)

  # t@C̏
  open(fname, 'rb') do |f|
    f.extend Bitio

    # ZOge[u̎擾
    f.read(64)
    segs = []
    loop do
      pos, size = f.read(8).unpack('NN')
      break if pos.zero?
      segs.push([pos, size])
    end

    # [gfBNg̎擾
    rootdir = []
    pos, size = segs[ROOT_SEGN]
    f.pos = pos
    (size / 16).times do
      name, id, flag, segnum = f.read(16).unpack('A10A3Cn')
      if flag == 0x01
        rootdir.push(segnum)
      end
    end

    rootdir.each do |segnum|
      datasegnum = getsegnum(f, segs, SEGNAME_DATA, segnum)
      filesegnum = getsegnum(f, segs, SEGNAME_FILE, segnum)

      next if datasegnum.nil? || filesegnum.nil?

      # t@Ce[u̎擾
      segpos, segsize = segs[filesegnum]
      f.pos = segpos
      f.read(16)
      fcount, tpos, fnamesize, fnamepos = f.read(16).unpack('N4')
      f.pos = segpos + tpos
      files = []
      fcount.times do
        pos, size, unknown, fnum = f.read(16).unpack('N4')
        files.push([pos, size, fnum])
      end
      f.pos = segpos + fnamepos
      xmlnames = []
      fcount.times do
        fnum, xmlname = f.read(4 + fnamesize).unpack('NA*')
        xmlnames[fnum] = xmlname.sub(/\..*$/, '') + '.xml'
      end

      # f[^ZOg̏Jn
      segpos, segsize = segs[datasegnum]

      # et@CubN̏
      files.each do |pos, size, fnum|
        top = segpos + pos  # t@CubN̐擪ʒu
        f.pos = top

        # wb_[擾
        header = f.read(20)
        a = header.unpack('N5')
        hpos = a[2]    # nt}؃f[^̈ʒu
        tpos = a[4]    # y[We[üʒu

        # nt}؍쐬
        f.pos = top + hpos
        root, tree = maketree(f)

        # y[We[u擾
        f.pos = top + tpos
        pages = []
        pagepos, pagesize, realsize = f.read(12).unpack('N3')
        pages.push([pagepos, pagesize, realsize])
        pagetop = pagepos     # 擪y[Ẅʒu
        while f.tell < (top + pagetop)
          pagepos, pagesize, realsize = f.read(12).unpack('N3')
          pages.push([pagepos, pagesize, realsize])
        end

        # o̓t@C
        outfname = xmlnames[fnum]
        outf = open(File::join(outdir, outfname), 'wb')

        # ey[ẄkWJƏo
        n = 0
        pages.each do |pagepos, pagesize, realsize|
          n += 1
break if $DEBUG && (n >= 3)
          STDERR.print outfname, ': ', n, '/', pages.size, "\r"
          f.pos = top + pagepos
          outf.write(decode(f, root, tree, realsize))
        end
        STDERR.print outfname, ': ', n, '/', pages.size, "\n"

        outf.close
      end
    end
  end # open

end

###

  # ̃`FbN
  begin
    raise "\nt@Cw肵Ă" if ARGV.size < 1
  rescue => e
    showHelp()
    STDERR.puts e.message
    exit 2
  end

  fname = ARGV.shift.gsub(/\\/, '/')
  outdir = if ARGV.size > 0 then ARGV.shift.gsub(/\\/, '/') else '.' end
  outdir.sub!(/\/$/, '')

  start = Time::now
  STDERR.print "Jn: ", start.strftime('%Y-%m-%d %X'), "\n"

  extract(fname, outdir)

  finish = Time::now
  STDERR.print "I: ", finish.strftime('%Y-%m-%d %X'), "\n"
  STDERR.print ": ", Time::at(finish.to_i - start.to_i).utc.strftime('%X'), "\n"

